PROBLEM LINK:Author: Vitalij Kozhukhivskij DIFFICULTY:Easy PREREQUISITES:Dynamic programming, subarray sums, prefix sums, segment trees PROBLEM:There is a grid of $N\times N$ cells. The $N$ blocks of each column are made up of soil, except for a contiguous sequence of cells: from the $l_i$th cell to the $h_i$th cell (starting from the bottom, $0$indexing). Cells can be cleared of soil. We need to create a subgrid of length $N$ and height $H$ containing no soil. What is the minimum number of cells needed to be cleared of soil? QUICK EXPLANATION:There are only $NH+1$ possible $N\times H$ subgrids. The answer is the the minimum number of soil cells among all such subgrids. We can preprocess our grid so we can compute the sum of each subgrid in constant time. To preprocess:
Then the number of soil cells in each $N\times H$ subgrid can be computed as $s_i  s_{iH}$ for $H \le i \le N$. EXPLANATION:Clearly, we need to find the $N\times H$ subgrid with the minimum number of soil cells in it. There are only $NH+1$ such subgrids: the following illustrates the case $N = 7$ and $H = 3$ (there are $NH+1 = 5$ subgrids):
We can simply construct the $N\times N$ grid, and compute the number of soil cells in these subgrids. Since there are $NH+1$ subgrids and each one has $NH$ cells to check, this algorithm runs in $O((NH+1)NH)$ time. The worst case is when $H$ is around half of $N$ (which makes the running time $O(N^3)$), so unfortunately this algorithm is only good for the first subtask. For the second subtask, you can't even store the whole grid due to the memory requirements! To answer the second subtask, we need a way to sum up these subgrids without constructing the whole grid. The first thing we notice is that the only information we need from its row is the number of soil cells in it, i.e. we don't need to know their positions in the row. Let's say the $i$th row ($0 \le i < N$) contains $r_i$ soil cells. Then the number of soil cells in each of the $NH+1$ subgrids are the following:
The smallest of these is the answer! Thus, it would be very helpful if we can compute the sequence $r_0, r_1, \ldots, r_{N1}$ quickly, without constructing the whole grid! To do so, we use the following observation: $r_i$ is equal to the number of $j$s such that $0 \le j < N$ and $i < l_j$ or $i > h_j$. Now, counting all such $j$s this way is still not fast enough, so we do some manipulations first. For a statement $\phi(j)$, let $C_{\phi(j)}$ be the number of $j$s such that $0 \le j < N$ and $\phi(j)$ is true. To familiarize yourself with this notation, we give a few basic facts (we invite you to verify each one):
Now, back to $r_i$. We have the following (using some of the facts above: $$\begin{align*} r_i &= C_{i < l_j \text{ or } i > h_j} \\\ &= N  C_{\text{not } (i < l_j \text{ or } i > h_j)} \\\ &= N  C_{i \ge l_j \text{ and } i \le h_j} \\\ &= N  C_{l_j \le i \le h_j} \\\ &= N  (C_{i \le h_j}  C_{i < l_j}) \end{align*}$$ The last one is true because $l_j \le h_j$. Now, we have: $$r_i = N  C_{i \le h_j} + C_{i < l_j}$$ To compute the $r_i$s, we just need to compute the quantity $ C_{i \le h_j} + C_{i < l_j}$ for all $0 \le i < N$. The key to this is to notice that $r_i$ can be computed by a simple adjustment from $r_{i1}$! In other words, we can just calculate the difference $r_i  r_{i1}$, and if we have already computed $r_{i1}$, then we can calculate $r_i$ by adding this difference. In more detail, let's try to compute $r_i  r_{i1}$: $$\begin{align*} r_i  r_{i1} &= (N  C_{i \le h_j} + C_{i < l_j})  (N  C_{i1 \le h_j} + C_{i1 < l_j}) \\\ &= N  C_{i \le h_j} + C_{i \le l_j1}  N + C_{i \le h_j+1}  C_{i \le l_j} \\\ &= C_{i \le h_j+1}  C_{i \le h_j} + C_{i \le l_j1}  C_{i \le l_j} \\\ &= (C_{i \le h_j+1}  C_{i \le h_j}) + (C_{i \le l_j1}  C_{i \le l_j}) \\\ &= C_{i = h_j+1}  C_{i = l_j} \end{align*}$$ But we can compute the values $C_{i = h_j+1}$ and $C_{i = l_j}$ for $0 \le i < N$ quickly, via a linear pass of all pairs $(l_j,h_j)$ for $0 \le j < N$! The following pseudocode does it:
Now that all the $C_{i = h_j+1}$ and $C_{i = l_j}$ are computed, we can now compute all the $r_i$s using the following recurrence: $$r_{1} = N$$ $$r_i = r_{i1} + C_{i = h_j+1}  C_{i = l_j}$$ The following pseudocode does it:
Clearly, these pseudocodes run in $O(N)$ time! Finally, to compute the answer, we need to know the following sums:
and then compute the minimum among them. But this is easy! Notice that $r_i + r_{i+1} + \cdots + r_j$ is simply $(r_0 + \cdots + r_j)  (r_0 + \cdots + r_{i1})$, so we can first try computing the prefix sums. Let $s_i$ be the sum $r_0 + r_1 + \cdots + r_{i1}$. Then $r_i + r_{i+1} + \cdots + r_j$ is simply $s_{j+1}  s_i$. The $s_i$s can be computed in $O(N)$ too, because $s_i = s_{i1} + r_{i1}$, with the base case $s_0 = 0$. Afterwards, the sums we need are simply:
Since all the steps of this algorithm runs is $O(N)$, the answer can thus be computed in $O(N)$ time in total! The following is a sample implementation in Python:
A few things to notice about this implementation:
Time Complexity:$O(N)$ AUTHOR'S AND TESTER'S SOLUTIONS:
This question is marked "community wiki".
asked 16 Aug '15, 13:06

why editorialists use too much complex thing which really hard to understand why cann't they use some images or any other resources to easily visualization of things... this question was quite easy who knows about BIT/segment tree data structure(I also know...): P but moment I saw explanation I got stuck and think is this question that much difficult?? is there a way where user also can make editorial too??.1. Happy coding answered 18 Aug '15, 00:59
Dude please tell me the easy way, this editorial has just crossed my head.
(29 Mar '16, 07:07)
@rcsldav yes
(31 Jan, 00:10)

WAYOUT was a regular BIT/segment tree problem. To make the users think about O(n) solution rather than O(nlogn), the time limit could have been made strict, maybe 0.5 seconds or n<=10^6. BIT solution link https://www.codechef.com/viewsolution/7723896. answered 17 Aug '15, 19:53

WAYOUT was a regular BIT/segment tree problem. To make the users think about O(n) solution rather than O(nlogn), the time limit could have been made strict, maybe 0.5 seconds or N<=10^6 answered 17 Aug '15, 19:51

Can someone please explain why my code gives WA on some of the test cases of subtask 2 WOUT answered 17 Aug '15, 21:03
2
for integer value of constraints answer can be large more than integer limit that's why you got WA it is advice to keep everything in long long for every question from now on :)
(17 Aug '15, 23:29)
(18 Aug '15, 00:36)
@admin...but if long long int is required only by 2 or 3 variable why we declare all variable long long int...it slow down solution..because that can not handle at time in 64bit machine it require double time compare int calculation because long long int 128bit long variable cpu stored it into twoplace and do calculation which simply increase the time required by machine to variable manipulation and calculation... I think it is not good advice...you should only be aware which variable might get value out of range of int[2^16 2^161] integer range is quite long no need too worry much
(18 Aug '15, 00:49)

Because everything is in int and ans can come out to be in long. answered 17 Aug '15, 23:20

Awesome solution! I dunno why the other users are complaining. Even I used a BIT solution to solve this. Thanks for showing me a faster way! answered 18 Aug '15, 18:56

Segment Tree solution of WayOut: https://www.codechef.com/viewsolution/7856183 answered 18 Aug '15, 21:27

this is not a dp question too a far and large extent .. why wrong tag ?? answered 31 Jan, 00:10

@admin... but if long long int is required only by 2 or 3 variable why we declare all variable long long int...it slow down solution..because that can not handle at time in 64bit machine it require double time compare int calculation because long long int 128bit long variable cpu stored it into twoplace and do calculation which simply increase the time required by machine to variable manipulation and calculation... I think it is not good advice...you should only be aware which variable might get value out of range of int[2^16 2^161] integer range is quite long no need too worry much just take care of range only some cases.... Happy coding... answered 18 Aug '15, 00:50

I used the same algorithm with Big(O) complexity but still I got TLE , I still don't understand Can anyone help me ? i am new to coding contests I solved a lot of practice problems although https://www.codechef.com/viewsolution/7804230 https://www.codechef.com/viewsolution/7806640 answered 18 Aug '15, 21:34

What do we mean by this statement Let C[ϕ(j)] be the number of js such that 0≤j<N and ϕ(j) is true. answered 19 Aug '15, 16:45

what do we mean by this statement Let C[ϕ(j)] be the number of js such that 0≤j<N and ϕ(j) is true. answered 19 Aug '15, 16:47

Why my segment tree solution has not passed and given TLE please explain answered 21 Aug '15, 09:01

Hi , I used the following approach for solving the problem without using bit/segment trees. https://www.codechef.com/viewsolution/7726107 Hope this helps!! answered 20 Sep '15, 13:23

I am getting wrong answer in 2 sections of subtask 2. Could somebody look and point out what me be wrong. Here is a link to my solution: https://www.codechef.com/submit/complete/11254238 answered 27 Aug '16, 04:01
